--[[
	BarKeep_ButtonFacade
	Based on Blizz_ButtonFacade written by North101
	Made by: platykurtic
	
BarKeep, a World of Warcraft addon to manage the Blizzard Bars.
Copyright (C) 2007 Platykurtic except the code which others created.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
]]
local LibButtonFacade = LibStub("LibButtonFacade",true)
if not LibButtonFacade then return end

function BarKeep_ButtonFacade_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function BarKeep_ButtonFacade_OnEvent(event)
	if event == "VARIABLES_LOADED" then
		if BarKeep_ButtonFacade == nil  then BarKeep_ButtonFacade_LoadDefault() end
		-- temporary code for adding new settings elegantly

	elseif event == "PLAYER_ENTERING_WORLD" then
		BarKeep_ButtonFacade_Init()
	end
end

function BarKeep_ButtonFacade_LoadDefault()
	BarKeep_ButtonFacade = {}
	BarKeep_ButtonFacade.Skin = "Blizzard"
end

function BarKeep_ButtonFacade_Init()
	-- Set the function to Add the Buffs
	local function BarKeep_ButtonFacade_AddBuffs()
		LibButtonFacade:Group("BarKeep", "Buffs"):AddButton(this)
	end
	LibButtonFacade:Group("BarKeep", "Buffs"):Skin(BarKeep_ButtonFacade.Skin)
	hooksecurefunc("BuffButton_OnLoad", BarKeep_ButtonFacade_AddBuffs)
	hooksecurefunc("TempEnchantButton_OnLoad", BarKeep_ButtonFacade_AddBuffs)
	
	-- Register the  Bars/Buttons with ButtonFacade
	LibButtonFacade:Group("BarKeep", "ActionButtons"):Skin(BarKeep_ButtonFacade.Skin)
	LibButtonFacade:Group("BarKeep", "BonusActionButtons"):Skin(BarKeep_ButtonFacade.Skin)
	LibButtonFacade:Group("BarKeep", "MultiBarBottomLeftButtons"):Skin(BarKeep_ButtonFacade.Skin)
	LibButtonFacade:Group("BarKeep", "MultiBarBottomRightButtons"):Skin(BarKeep_ButtonFacade.Skin)
	LibButtonFacade:Group("BarKeep", "MultiBarLeftButtons"):Skin(BarKeep_ButtonFacade.Skin)
	LibButtonFacade:Group("BarKeep", "MultiBarRightButtons"):Skin(BarKeep_ButtonFacade.Skin)
	for i=1, 12 do
		LibButtonFacade:Group("BarKeep", "ActionButtons"):AddButton(_G[("ActionButton%d"):format(i)])
		LibButtonFacade:Group("BarKeep", "BonusActionButtons"):AddButton(_G[("BonusActionButton%d"):format(i)])
		LibButtonFacade:Group("BarKeep", "MultiBarBottomLeftButtons"):AddButton(_G[("MultiBarBottomLeftButton%d"):format(i)])
		LibButtonFacade:Group("BarKeep", "MultiBarBottomRightButtons"):AddButton(_G[("MultiBarBottomRightButton%d"):format(i)])
		LibButtonFacade:Group("BarKeep", "MultiBarLeftButtons"):AddButton(_G[("MultiBarLeftButton%d"):format(i)])
		LibButtonFacade:Group("BarKeep", "MultiBarRightButtons"):AddButton(_G[("MultiBarRightButton%d"):format(i)])
	end

	LibButtonFacade:Group("BarKeep", "ShapeshiftButtons"):Skin(BarKeep_ButtonFacade.Skin)
	LibButtonFacade:Group("BarKeep", "PetActionButtons"):Skin(BarKeep_ButtonFacade.Skin)
	for i=1, 10 do
		LibButtonFacade:Group("BarKeep", "ShapeshiftButtons"):AddButton(_G[("ShapeshiftButton%d"):format(i)])
		LibButtonFacade:Group("BarKeep", "PetActionButtons"):AddButton(_G[("PetActionButton%d"):format(i)])
	end

	LibButtonFacade:Group("BarKeep", "PossessButtons"):Skin(BarKeep_ButtonFacade.Skin)
	for i=1, 2 do
		LibButtonFacade:Group("BarKeep", "PossessButtons"):AddButton(_G[("PossessButton%d"):format(i)])
	end

	LibButtonFacade:Group("BarKeep", "VehicleMenuBarActionButtons"):Skin(BarKeep_ButtonFacade.Skin)
	for i=1, 6 do
		LibButtonFacade:Group("BarKeep", "VehicleMenuBarActionButtons"):AddButton(_G[("VehicleMenuBarActionButton%d"):format(i)])
	end
--[[	LibButtonFacade:Group("BarKeep", "VehicleMenuBarActionButtons"):AddButton(_G["VehicleMenuBarPitchUpButton"])
	LibButtonFacade:Group("BarKeep", "VehicleMenuBarActionButtons"):AddButton(_G["VehicleMenuBarPitchDownButton"])
	LibButtonFacade:Group("BarKeep", "VehicleMenuBarActionButtons"):AddButton(_G["VehicleMenuBarLeaveButton"])]]
	
	-- Set the skin change function
	local function BarKeep_ButtonFacade_SkinChange(arg, SkinID, Gloss, Backdrop, Group, Button, Colors, ...)
		if (not Group == "BarKeep") then return end
		BarKeep_ButtonFacade.Skin = SkinID
	end
	LibButtonFacade:RegisterSkinCallback("BarKeep", BarKeep_ButtonFacade_SkinChange, self)
end
